#include "blowfish.as"


#define WIN_X 580
#define WIN_Y 340

	__progname = "blowfish driver"
	sdim encrypt, 1024 * 6, 1
	sdim decrypt, 1024 * 6, 1
	sdim strings, 1024, 1
	sdim key, BLOWFISH_MAXKEYBYTES, 1
	int ctx

	screen 0, WIN_X, WIN_Y, 1
	palette 21, 192, 192, 192
	palfade
	palcolor 21
	boxf 0, 0, WIN_X, WIN_Y
	color 0, 0, 0
	title __progname

	gsel 0, 1

	pos 10, 10
	mes "input:"
	pos 75, 10
	mesbox strings, 330, 26 * 2, 1

	pos 10, 70
	mes "key:"
	pos 75, 70
	input key, 330, 26, BLOWFISH_MAXKEYBYTES

	pos 10, 110
	mes "encrypt:":
	pos 75, 110
	mesbox encrypt, 480, 100, 1

	pos 10, 220
	mes "decrypt:"
	pos 75, 220
	mesbox decrypt, 480, 100, 1

	objsize 140, 26, 30
	pos 430, 10
	button "encrypt string",   *EncryptString
	button "decrypt string",   *DecryptString
	button "exit",             *endprog

*noop
	objprm 2, encrypt
	objprm 3, decrypt
	stop

*endprog
	if lock: blowfish_clean ctx
	end

*EncryptString
	if key = "": encrypt = "(null)": goto *noop
	;; ȂǂReNXg𐶐Ȃ悤
	;; ȒPȔr
	if lock: blowfish_clean ctx
	blowfish_init key
	lock = 1
	ctx = stat
	encrypt = strings
	strlen len, strings
	blowfish_encrypt encrypt, len, ctx
	goto *noop

*DecryptString
	if key = "": decrypt = "(null)": goto *noop
	if lock = 0: goto *noop
	decrypt = encrypt
	strlen len, strings
	;; obt@TCY BLOWFISH_BLOCKBYTES ̋Eɒ邱
	blowfish_decrypt decrypt, (len / BLOWFISH_BLOCKBYTES + 1) * BLOWFISH_BLOCKBYTES, ctx
	blowfish_clean ctx
	lock = 0
	goto *noop
	stop
